#!/bin/bash

# Sie koennen folgende Parameter anpassen:
PfadA="/usr/share/gnome-background-properties"
PfadB="/usr/share/backgrounds/contest"
transitionTime="1795.0"
duration="5.0"
# Pfad ist je nach Distribution unterschiedlich!


# Programmbeginn
CWD=$(pwd)

clear
i=-1

echo "-----<>----- -----------<>--------- -----<>-----"
echo "-----<>-----   DESKTOP BACKGROUND   -----<>-----"
echo "-----<>-----  GENERATOR FOR UBUNTU  -----<>-----"
echo "-----<>-----         VER 0.1a       -----<>-----"
echo "-----<>----- -----------<>--------- -----<>-----"
echo "-----<>----- OPTIONS:               -----<>-----"
echo "-----<>----- -o : OVERWRITES FILES  -----<>-----"
echo "-----<>----- -----------<>--------- -----<>-----"
echo "-----<>-----  (C) RENÉ VOLLMER 2015 -----<>-----"
echo "-----<>-----         BASED ON       -----<>-----"
echo "-----<>-----       IMAGEMAGNICK     -----<>-----"
echo "-----<>----- -----------<>--------- -----<>-----"
echo "Prefaces:"
echo "-This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version."

read -p "Do you know what the 'GNU General Public License' is (y/n)?" yn
case $yn in
	[Yy]* ) echo "Great! So here some more information about this script";;
	[Nn]* ) echo "Here is what is important:
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.";;
	* ) echo "Please answer yes or no.";;
esac

echo "-This script creates two files that will enable you to change your background to a 'slideshow'"
echo "-This slideshow will consist of all images in the same folder as this script"
echo "-If you want to undo what this script does you'll have to do it manually - instructions at the end of this file"
echo "-This has only been tested under Ubuntu 14.04 LTS. It should work on later versions of Ubuntu but is unlikely to work on other distributions"
echo "-The image-files should not be moved after this script run"
echo " "
read -p "Do you agree to this and want to continue (y/n)?" yn
case $yn in
	[Yy]* ) echo "";;
	[Nn]* ) echo "Goodbye then!"; exit;;
	* ) echo "Please answer yes or no.";;
esac
echo "-----<>----- -----------<>--------- -----<>-----"
echo -n "-----<>-----    Initialisation."

#Zaehle zu verarbeitene Bilder
for file in *.jpg -or *.JPG; do
	i=$(($i+1))
	#echo "$file"
done
echo -n "."

echo ".   -----<>-----"
echo "-----<>----- -----------<>--------- -----<>-----"

echo "Your slideshow will consits of $i pictures (from '$CWD')."
echo "Each pictures will be displayed for $transitionTime seconds."
echo " "
read -p "How should your Profile be named? (Human-readable) :> " name
echo " "
echo "Following BG-Image-Profiles are existing:"
ls -t $PfadA
read -p "How should your files for the Profile be named? (without .xml) :> " fileName
echo " "
echo " "

dateiA="$PfadA/$fileName.xml"
dateiB="$PfadB/$fileName.xml"

inhaltA="<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<!DOCTYPE wallpapers SYSTEM \"gnome-wp-list.dtd\">
<wallpapers>
  <wallpaper deleted=\"false\">
    <name>$name</name>
    <filename>$dateiB</filename>
    <options>zoom</options>
  </wallpaper>"

inhaltB="<background>
  <starttime>
    <year>2009</year>
    <month>01</month>
    <day>01</day>
    <hour>00</hour>
    <minute>00</minute>
    <second>00</second>
  </starttime>"


#Ueberschreiben?while true; do
if [ -e "$dateiA" ]
then
	while [ $1 ]
	  do
	    [ $1 == "-o" ] && ersetzen="yes" && shift
	done

	if [ "$ersetzen" != "yes" ]
	then
		read -p "Do you wish to overwrite existing files (y/n)?" yn
		case $yn in
			[Yy]* ) ersetzen="yes";;
			[Nn]* ) echo "Goodbye then!"; exit;;
			* ) echo "Please answer yes or no.";;
		esac
	fi
fi




n=0
last=""
for file in *.jpg -or *.JPG; do

	if [ "$file" != "*.JPG" ]
	then

	(( n++ )) 

	if [ $n -eq 1 ]
	then
		first=$file
	fi

	if [ "$file" != "-or" ]
	then
		inhaltA="$inhaltA
  <wallpaper>
    <name>$name $n</name>
    <filename>$CWD/$file</filename>
    <options>zoom</options>
    <pcolor>#000000</pcolor>
    <scolor>#000000</scolor>
    <shade_type>solid</shade_type>
  </wallpaper>"

		if [ "$last" != "" ]
		then
			inhaltB="$inhaltB
  <transition>
    <duration>$duration</duration>
    <from>$CWD/$last</from>
    <to>$CWD/$file</to>
  </transition>"
		fi
		inhaltB="$inhaltB
  <static>
    <duration>$transitionTime</duration>
    <file>$CWD/$file</file>
  </static>"
		last="$file"
	fi

	if [ $n -eq $((i-1)) ]
	then
		inhaltB="$inhaltB
  <transition>
    <duration>5.0</duration>
    <from>$CWD/$last</from>
    <to>$CWD/$first</to>
  </transition>"
	fi
	fi
done

inhaltA="$inhaltA
</wallpapers>"
inhaltB="$inhaltB
</background>"


echo "$inhaltA" > "$dateiA"
echo "$inhaltB" > "$dateiB"

echo " "
echo " "
echo "-----<>----- -----------<>--------- -----<>-----"
echo " "
echo "Files created."
echo "To activate the slideshow right-Click on desktop > Change desktop background > Select the last item with the clock"
echo " "
echo "Do not (re)move the pictures. If you do you'll have to run this script again."
echo " "
echo "If you want to remove the wallpapers simply delete"
echo "$dateiA"
echo "and"
echo "$dateiB"
echo "or overwrite them by running this script with the same filename."
echo " "
echo " "
echo "Thanks for using this script! Visit www.Aypac.de if it pleases you :)"
echo "-----<>----- -----------<>--------- -----<>-----"
read -p "Press [Enter] key to close..."
echo " "

exit
# Programmende	
